# coding: utf-8

"""
    CredentialIssuanceService

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.0
    Contact: info@affinidi.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, validator

class IssuanceStateResponse(BaseModel):
    """
    IssuanceStateResponse
    """
    issuance_id: StrictStr = Field(default=..., alias="issuanceId", description="Website's internal identifier. Website may use to get info about the status of issuance flow. If it is not provided, CIS will generate one.")
    status: StrictStr = Field(default=..., description="String describing the status of the issuance")
    __properties = ["issuanceId", "status"]

    @validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('INIT', 'OFFER_DELIVERED', 'VC_CLAIMED', 'TIMEOUT'):
            raise ValueError("must be one of enum values ('INIT', 'OFFER_DELIVERED', 'VC_CLAIMED', 'TIMEOUT')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IssuanceStateResponse:
        """Create an instance of IssuanceStateResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IssuanceStateResponse:
        """Create an instance of IssuanceStateResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IssuanceStateResponse.parse_obj(obj)

        _obj = IssuanceStateResponse.parse_obj({
            "issuance_id": obj.get("issuanceId"),
            "status": obj.get("status")
        })
        return _obj


